/*
 * DTLZ2.c
 *
 * Authors:
 *  Renzhi Chen <rxc332@cs.bham.ac.uk>
 *  Ke Li <k.li@exeter.ac.uk>
 *
 * Copyright (c) 2017 Renzhi Chen, Ke Li
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#define FF 1
#include "../../header/problems.h"
#include "../../header/global.h"

FILE *input = NULL;
int countt= 0;

void dtlz2 (individual_real *ind)
{
    int i, j, k;
    int aux;
    double gx;
    double *xreal, *obj;

    obj   = ind->obj;
    xreal = ind->xreal;

/*
    if(FF)
    {
        if(input == NULL) {
            input = fopen("test.in", "r");
            countt = 0;
        }
        else{
            for(i=0;i<number_variable;i++)
            {
                fscanf(input,"%lf",&ind->xreal[i]);
                printf("%lf",ind->xreal[i]);
            }
            countt ++;

            if(countt==popsize)
            {
                fclose(input);
                countt = 0;
                input = NULL;
            }
            printf("\n");
        }

    }
*/
    double sum = 0;
    double xtemp[100];
    for (i=0;i<number_variable;i++)
    {

        xtemp[i] = xreal[i]*xreal[((i+number_variable)/2)%number_variable];
    }
    xreal = xtemp;

    gx = 0.0;
    k  = number_variable - number_objective + 1;
    for(i = number_variable - k; i < number_variable; i++)
        gx += pow((xreal[i] - 0.5), 2.0);

    for (i = 0; i < number_objective; i++)
        obj[i] = 1.0 + gx;

    for (i = 0; i < number_objective; i++)
    {
        for (j = 0; j < number_objective - (i + 1); j++)
            obj[i] *= cos(PI * 0.5 * xreal[j]);
        if (i != 0)
        {
            aux     = number_objective - (i + 1);
            obj[i] *= sin(PI * 0.5 * xreal[aux]);
        }
    }
    //if(xtemp!=NULL)free(xtemp);
}
